<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Hash Tables</TITLE>
<link href="suif1_98.html" rel=Next>
<link href="suif1_96.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_96.html">previous</A>, <A HREF="suif1_98.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC97" HREF="suif1_toc.html#TOC97">Hash Tables</A></H2>
<P>
<A NAME="IDX683"></A>

</P>
<P>
<A NAME="IDX684"></A>
<A NAME="IDX685"></A>
<A NAME="IDX686"></A>
SUIF hash tables are implemented by the <CODE>hash_table</CODE> class in the
files <TT>`hash.h'</TT> and <TT>`hash.cc'</TT>.  Each hash table is a fixed-size
array of <CODE>hash_chain</CODE> buckets.  A <CODE>hash_chain</CODE> is just a
move-to-front list.  See section <A HREF="suif1_93.html#SEC93">Move-to-front Lists</A>.  The entries in a hash
table are derived from the <CODE>hash_e</CODE> class, which contains a single
unsigned value used as the signature.

</P>
<P>
If you wish to store pointers in a hash table, you can use the
<CODE>hash_e</CODE> class directly (assuming that the pointers can fit into
the unsigned signature fields).  Otherwise, you need to create a derived
<CODE>hash_e</CODE> class.  The only other thing needed is a function to
compare two <CODE>hash_e</CODE> entries to determine if they are equal.  You
can then create a new <CODE>hash_table</CODE> object.  Even if you are using a
derived <CODE>hash_e</CODE> class, it may be easier to just type cast the
pointers than to derive a new <CODE>hash_table</CODE> class that includes the
correct type casts.

</P>
<P>
<A NAME="IDX687"></A>
<A NAME="IDX688"></A>
The hash table <CODE>enter</CODE> method tries to add a new entry.  If the
entry was already in the table it returns <CODE>TRUE</CODE> and does not enter
a duplicate; otherwise, it adds the new entry and returns <CODE>FALSE</CODE>.
The <CODE>lookup</CODE> method checks to see if a particular entry is in the
table.  If so, it returns the pointer to the entry.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_96.html">previous</A>, <A HREF="suif1_98.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
